# Generated by Django 4.2.17 on 2025-01-07 06:26

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="PlanExecutionModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("state", models.TextField(default="PENDING")),
                ("start_time", models.DateTimeField(null=True)),
                ("pause_time", models.DateTimeField(null=True)),
                ("finish_time", models.DateTimeField(null=True)),
                ("schedule_time", models.DateTimeField(null=True)),
                ("trigger_id", models.TextField()),
                ("evidence_directory", models.TextField()),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="PlanModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.TextField()),
                ("metadata", models.JSONField()),
                ("dynamic", models.BooleanField(default=False)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="PlanSettings",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("separator", models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name="PlanTemplateModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("file", models.FileField(upload_to="uploads/")),
            ],
        ),
        migrations.CreateModel(
            name="StageExecutionModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("state", models.TextField(default="PENDING")),
                ("start_time", models.DateTimeField(null=True)),
                ("pause_time", models.DateTimeField(null=True)),
                ("finish_time", models.DateTimeField(null=True)),
                ("schedule_time", models.DateTimeField(null=True)),
                ("serialized_output", models.JSONField(default=dict)),
                ("output", models.TextField(default="")),
                ("trigger_id", models.TextField()),
                (
                    "plan_execution",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="stage_executions",
                        to="cryton_app.planexecutionmodel",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="StageModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.TextField()),
                ("metadata", models.JSONField()),
                ("type", models.TextField()),
                ("arguments", models.JSONField()),
                (
                    "plan",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, related_name="stages", to="cryton_app.planmodel"
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="StepModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.TextField()),
                ("metadata", models.JSONField()),
                ("is_init", models.BooleanField()),
                ("is_final", models.BooleanField()),
                ("module", models.TextField()),
                ("arguments", models.JSONField()),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="StepOutputSettingsModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("alias", models.TextField()),
                ("replace", models.JSONField()),
            ],
        ),
        migrations.CreateModel(
            name="WorkerModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.TextField()),
                ("description", models.TextField()),
                ("state", models.TextField(default="DOWN")),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="SuccessorModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("type", models.TextField()),
                ("value", models.TextField()),
                (
                    "parent",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="successors",
                        to="cryton_app.stepmodel",
                    ),
                ),
                (
                    "successor",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, related_name="parents", to="cryton_app.stepmodel"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="stepmodel",
            name="output_settings",
            field=models.OneToOneField(
                on_delete=django.db.models.deletion.CASCADE, to="cryton_app.stepoutputsettingsmodel"
            ),
        ),
        migrations.AddField(
            model_name="stepmodel",
            name="stage",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, related_name="steps", to="cryton_app.stagemodel"
            ),
        ),
        migrations.CreateModel(
            name="StepExecutionModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("state", models.TextField(default="PENDING")),
                ("start_time", models.DateTimeField(null=True)),
                ("pause_time", models.DateTimeField(null=True)),
                ("finish_time", models.DateTimeField(null=True)),
                ("serialized_output", models.JSONField(default=dict)),
                ("output", models.TextField(default="")),
                ("valid", models.BooleanField(default=False)),
                (
                    "parent",
                    models.ForeignKey(
                        null=True, on_delete=django.db.models.deletion.CASCADE, to="cryton_app.stepexecutionmodel"
                    ),
                ),
                (
                    "stage_execution",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="step_executions",
                        to="cryton_app.stageexecutionmodel",
                    ),
                ),
                (
                    "step",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="step_executions",
                        to="cryton_app.stepmodel",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AddField(
            model_name="stageexecutionmodel",
            name="stage",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, related_name="stage_executions", to="cryton_app.stagemodel"
            ),
        ),
        migrations.CreateModel(
            name="StageDependencyModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                (
                    "dependency",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="subjects_to",
                        to="cryton_app.stagemodel",
                    ),
                ),
                (
                    "stage",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="dependencies",
                        to="cryton_app.stagemodel",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="RunModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("state", models.TextField(default="PENDING")),
                ("start_time", models.DateTimeField(null=True)),
                ("pause_time", models.DateTimeField(null=True)),
                ("finish_time", models.DateTimeField(null=True)),
                ("schedule_time", models.DateTimeField(null=True)),
                ("trigger_id", models.TextField()),
                (
                    "plan",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, related_name="runs", to="cryton_app.planmodel"
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AddField(
            model_name="planmodel",
            name="settings",
            field=models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to="cryton_app.plansettings"),
        ),
        migrations.AddField(
            model_name="planexecutionmodel",
            name="plan",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, related_name="plan_executions", to="cryton_app.planmodel"
            ),
        ),
        migrations.AddField(
            model_name="planexecutionmodel",
            name="run",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, related_name="plan_executions", to="cryton_app.runmodel"
            ),
        ),
        migrations.AddField(
            model_name="planexecutionmodel",
            name="worker",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT, related_name="plan_executions", to="cryton_app.workermodel"
            ),
        ),
        migrations.CreateModel(
            name="OutputMappingModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("name_from", models.TextField()),
                ("name_to", models.TextField()),
                (
                    "output_settings",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="mappings",
                        to="cryton_app.stepoutputsettingsmodel",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="ExecutionVariableModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.TextField()),
                ("value", models.JSONField()),
                (
                    "plan_execution",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="execution_variables",
                        to="cryton_app.planexecutionmodel",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="CorrelationEventModel",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("correlation_id", models.TextField()),
                (
                    "step_execution",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="correlation_events",
                        to="cryton_app.stepexecutionmodel",
                    ),
                ),
            ],
        ),
    ]
